#include <stdio.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

typedef struct _super_string {
    char *text;
    int size;
    int baseSize;
} SuperString;

bool ssWriteToFile(SuperString *ss, char *fileName);
SuperString *ssReadFromFile(char *fileName);
void showLines(char *fileName, char *word);

int main() {
//////// PROSOXH! Otan dokimasete aytoys toys kwdikes
//                frontiste na einai swsta ta paths
//                sta arxeia - katebaste ton kwdika
//                ws project!!

//////// WRITE SS TO FILE - example code
//    SuperString s1;
//    s1.text = "Dokimastiko";
//    s1.size = 15;
//    s1.baseSize = 5;
////
//    ssWriteToFile(&s1, "../sample-output.sup");

//////// READ SS FROM FILE - example code
//    SuperString *s2 = ssReadFromFile("../sample-output.sup");
//    if (s2 != NULL) {
//        printf("%s\n%d\n%d\n", s2->text, s2->size, s2->baseSize);
//    } else {
//        printf("ERROR!");
//    }

//////// SHOW LINES CONTAINING A WORD - example code
//    showLines("../some-text2.txt", "modularity");

    return 0;
}

// για απλοποίηση υποθέτουμε ένα μεγιστο μέγεθος γραμμής
// δεν είναι η βέλτιστη πρακτική αλλά κρατά τον κώδικά μας
// απλό στα πλαίσια του παραδείγματος
#define LINE_SIZE 4096

void showLines(char *fileName, char *word) {
    // ορίζω χώρο για μια γραμμή - θα μπορούσαμε να
    // χρησιμοποιήσουμε την malloc για πιο σωστά
    char textLine[LINE_SIZE];

    // ανίγουμε το αρχείο για διάβασμα ως κείμενο
    FILE *inputFile = fopen(fileName, "r");
    // εάν δεν άνοιξε
    if (inputFile == NULL) {
        // εμφανίζω το σφάλμα στην stderr
        // το να εμφανίσω το σφάλμα είναι αποδεκτό αφού
        // ο σκοπός της συνάρτησης είναι η εμφάνιση στην οθόνη
        fprintf(stderr, "Cannot open file '%s' to read it!\n", fileName);
        return;
    }

    // για κάθε γραμμή που διαβάζω από το αρχείο κειμένου =
    // = όσο δεν έχει τελειώσει το κείμενο
    while (fgets(textLine, LINE_SIZE, inputFile) != NULL) {
        // εάν μέσα στη γραμμή βρω τη λέξη (case sensitive)
        if (strstr(textLine, word) /*!= 0*/ ) {
            // εμφανίζω ολόκληρη τη γραμμή
            printf("%s", textLine);
        }
    }

    // στο τέλος κλείνω το αρχείο
    fclose(inputFile);
}

/*
 * Ο τρόπος που γίνεται η αποθήκευση και η ανάγνωση
 * από αυτές τις συναρτήσεις δεν είναι ο βέλτιστος.
 * Αποθηκεύεται αρκετή άχρηστη πληροφορία
 *
 * Επιλέχθηκε όμως για να είναι ο απλούστερος από
 * πλευράς κώδικα ως προς τη λειτουργία του.
 */
bool ssWriteToFile(SuperString *ss, char *fileName) {
    // ελέγχω το δεδομένο pointer
    if (ss == NULL) {
        // και τερματίζω με σφάλμα αν ήταν NULL
        return false;
    }

    // προσπαθώ να ανοίξω για δημιουργία σε binary
    // mode το αρχείο
    FILE *fout = fopen(fileName, "w+b");
    // εάν δεν ανοίξει
    if (fout == NULL) {
        // τερματίζω με σφάλμα
        return false;
    }

    // γράφω το κομμάτι μεγέθους ενός SuperString
    if (fwrite(ss, sizeof(SuperString), 1, fout) != 1) {
        // αν αποτύχει, κλείνω το αρχείο
        fclose(fout);
        // τερματίζω με σφάλμα
        return false;
    }

    // γράφω και το κείμενο που δείχνει το superstring
    if (fwrite(ss->text, sizeof(char), ss->size, fout) != ss->size) {
        // εάν αποτύχει η εγγραφή κλείνω το αρχείο
        fclose(fout);
        // τερματίζω με σφάλμα
        return false;
    }

    // όλα πήγαν καλά, οπότε κλείνω το αρχείο
    fclose(fout);
    // τερματίζω με ένδειξη επιτυχίας
    return true;
}

SuperString *ssReadFromFile(char *fileName) {
    // προσπαθώ να ανοίξω το αρχείο για ανάγνωση
    // σε binary mode
    FILE *fin = fopen(fileName, "rb");
    // αν δεν τα καταφέρω
    if (fin == NULL) {
        // τερματίζω με σφάλμα
        return NULL;
    }

    // δεσμεύω μνήμη για ένα SuperString
    SuperString *s = (SuperString *) malloc(sizeof(SuperString));
    // αν δεν υπάρχει
    if (s == NULL) {
        // κλείνω το αρχείο
        fclose(fin);
        // τερματίζω με σφάλμα
        return NULL;
    }
    // διαβάζω τα περιεχόμενα ενός SuperString στη μνήμη
    if (fread(s, sizeof(SuperString), 1, fin) != 1) {
        // αν δεν είναι δυνατόν αποδεσμεύω τη μνήμη του SuperString
        free(s);
        // κλείνω το αρχείο
        fclose(fin);
        // τερματίζω με σφάλμα
        return NULL;
    }

    // δεσμεύω μνήμη για το κείμενο, αφού ξέρω από το
    // SuperString που διάβασα το μέγεθός του
    s->text = (char *) malloc(sizeof(char) * s->size);
    // εάν δεν υπάρχει διαθέσιμη μνήμη
    if (s->text == NULL) {
        // αποδεσμεύω τη μνήμη του SuperString
        free(s);
        // κλείνω το αρχείο
        fclose(fin);
        // τερματίζω με σφάλμα
        return NULL;
    }

    // διαβάζω το κείμενο από το αρχείο
    int readBytes = fread(s->text, sizeof(char), s->size, fin);
    // εάν δεν διαβαστεί όσο περιμένω
    if (readBytes != s->size) {
        // αποδεσμεύω τη μνήμη του κειμένου
        free(s->text);
        // αποδεσμεύω τη μνήμη του SuperString
        free(s);
        // κλείνω το αρχείο
        fclose(fin);
        // τερματίζω με σφάλμα
        return NULL;
    }

    // βάζω μηδενικό κωδικό στο τέλος του κειμένου για σιγουριά
    s->text[s->size - 1] = 0;

    // κλείνω το αρχείο
    fclose(fin);
    // επιστρέφω τη δομή έτοιμη
    return s;
}
